

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
// РОБОТ-ШАР НА ДВУХ СЕРВОПРИВОДАХ ПЕРЕДЕЛАННЫХ НА ПОСТОЯННОЕ ВРАЩЕНИЕ
//
#include <Servo.h>
#define V1  10//правый мотор
#define V2  11//левый мотор

byte dPR=30; byte PR =76; //переменные хранения относительных значений скорости движения и покоя для правого и левого двигателей
byte dLE=25; byte LE =76;  
String inputString;// строки данных
int n=500;//временная пауза - размер в миллисек.
////////////////////////////
Servo servoPR;
Servo servoLE;
////////////////////////////
void setup ()
{
  Serial.begin(9600);
  servoPR.attach(V1);//вывод управления сервоприводом правым 
  servoPR.write(PR);// начальная скорость около 0 у сервы
  servoLE.attach(V2);//вывод управления сервоприводом левым 
  servoLE.write(LE);// начальная скорость около 0 у сервы
  
}
////////////////////////////
void loop()
{
  CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"

  if (cmd == "1") {
   servoPR.write(PR+dPR/2);//сперва едем вперёд медленно
   servoLE.write(LE-dLE/2);
   delay(n);  
   servoPR.write(PR+dPR);//едем вперёд
   servoLE.write(LE-dLE); 
   }
  if (cmd == "2") {
  servoPR.write(PR-dPR/2);//сперва едем назад медленно
  servoLE.write(LE+dLE/2);
  delay(n);   
  servoPR.write(PR-dPR);//едем назад
  servoLE.write(LE+dLE); 
    }
  if (cmd == "3") {
   servoPR.write(PR+dPR);//поворачиваем вправо
   servoLE.write(LE+dLE); 
   }
  if (cmd == "4") {
   servoPR.write(PR-dPR);//поворачиваем влево
   servoLE.write(LE-dLE); 
  }
  if (cmd == "A") {
   if(servoPR.read()-PR>0&&servoLE.read()-LE<0){ servoPR.write(PR+dPR/2);servoLE.write(LE-dLE/2);delay(n);}//сброс скорости перед остановкой при движ. вперёд
   if(servoPR.read()-PR<0&&servoLE.read()-LE>0){ servoPR.write(PR-dPR/2);servoLE.write(LE+dLE/2);delay(n);}//сброс скорости перед остановкой при движ. назад
   servoPR.write(PR);//исходное состояние-положение покоя
   servoLE.write(LE);  
  }

}
/////////////////////////////////////////////////////////////////////////////////

